/***********************************************************************/
/*    Transducer Block 1: Modbus TB                                    */
/***********************************************************************/

BLOCK transducer_block_1
{
    TYPE      TRANSDUCER;
    NUMBER    1;
}

trans1_blk_reserve                          LIKE VARIABLE    phys_blk_reserve
{
}

VARIABLE trans1_blk_object
{
    LABEL       [blk_block_object];
    HELP        [blk_block_object_help];
    CLASS       CONTAINED;
    TYPE        ENUMERATED(1)
    {
        {    3,    [blk_block_object_TRANSDUCER]        }
    }
    HANDLING    READ;
}

VARIABLE trans1_blk_parent_class
{
    LABEL       [blk_parent_class];
    HELP        [trans_blk_parent_class_help];
    CLASS       CONTAINED;
    TYPE        ENUMERATED(1)
    {
        {    128,    "Microcyber Custom"   }
    }
    HANDLING    READ;
}

VARIABLE trans1_blk_class
{
    LABEL       [blk_class];
    HELP        [trans_blk_class_help];
    CLASS       CONTAINED;
    TYPE        ENUMERATED(1)
    {
        DEFAULT_VALUE    4;
        {    1,        "IF105 Converter"              },
        {    2,        "FI105 Converter"              },
        {    3,        "Modbus PA Converter"          },
        {    4,        "M0307 Modbus to PA Module"    },
        {    5,        "G0307 Modbus to PA Gateway"   }
    }
    HANDLING    READ;
}
trans1_blk_dd_reference                     LIKE VARIABLE    phys_blk_dd_reference
{
}

trans1_blk_dd_rev                           LIKE VARIABLE    phys_blk_dd_rev
{
}

trans1_blk_profile                          LIKE VARIABLE    phys_blk_profile
{
}

trans1_blk_profile_rev                      LIKE VARIABLE    phys_blk_profile_rev
{
}

trans1_blk_execution_time                   LIKE VARIABLE    phys_blk_execution_time
{
}

trans1_blk_num_parameters                   LIKE VARIABLE    phys_blk_num_parameters
{
}

trans1_blk_index_view_1                     LIKE VARIABLE    phys_blk_index_view_1
{
}

trans1_blk_num_view_lists                   LIKE VARIABLE    phys_blk_num_view_lists
{
}

trans1_st_rev                               LIKE VARIABLE    phys_st_rev
{
}

trans1_tag_desc                             LIKE VARIABLE    phys_tag_desc
{
    REDEFINE LABEL        [MC_trans_tag_desc];
}

trans1_strategy                             LIKE VARIABLE    phys_strategy
{
}

trans1_alert_key                            LIKE VARIABLE    phys_alert_key
{
}

trans1_target_mode                            LIKE VARIABLE    phys_target_mode
{
}

trans1_actual_mode                            LIKE VARIABLE    phys_actual_mode
{
}

trans1_permitted_mode                        LIKE VARIABLE    phys_permitted_mode
{
}

trans1_normal_mode                            LIKE VARIABLE    phys_normal_mode
{
}

trans1_current_state_alarm_sum                LIKE VARIABLE    phys_current_state_alarm_sum
{
}

trans1_unacknowledged_state_alarm_sum        LIKE VARIABLE    phys_unacknowledged_state_alarm_sum
{
}

trans1_unreported_state_alarm_sum            LIKE VARIABLE    phys_unreported_state_alarm_sum
{
}

trans1_disabled_state_alarm_sum                LIKE VARIABLE    phys_disabled_state_alarm_sum
{
}

/*---------------------------------------------------------------------*/
/*    Transducer Block Parameter                                       */
/*---------------------------------------------------------------------*/
//VARIABLE    trans1_media
//{
//    LABEL           "Media" ;
//    HELP            "Media" ;
//    CLASS           CONTAINED ;
//    TYPE            ENUMERATED (1)
//    {
//        { 0x01,    "RS232",         "RS232" },
//        { 0x02,    "RS485",         "RS485" }
//    }
//    HANDLING        READ & WRITE ;
//}
VARIABLE    trans1_baud_rate
{
    LABEL           "Baud Rate" ;
    HELP            "Baud Rate" ;
    CLASS           CONTAINED ;
    TYPE            ENUMERATED (1)
    {
        DEFAULT_VALUE   2;
        { 0x00,    "2400",         "2400"  },
        { 0x01,    "4800",         "4800"  },
        { 0x02,    "9600",         "9600"  },
        { 0x03,    "14400",        "14400" },
        { 0x04,    "19200",        "19200" }
    }
    HANDLING        READ & WRITE ;
    CONSTANT_UNIT   "bps" ;    
}
VARIABLE    trans1_stop_bits
{
    LABEL           "Stop Bits" ;
    HELP            "Stop Bits" ;
    CLASS           CONTAINED ;
    TYPE            ENUMERATED (1)
    {
        { 0x00,    "One Stop Bit",         "One Stop Bit" },
        { 0x01,    "Two Stop Bits",         "Two Stop Bits" }
    }
    HANDLING        READ & WRITE ;
}
VARIABLE    trans1_parity
{
    LABEL           "Parity" ;
    HELP            "Parity" ;
    CLASS           CONTAINED ;
    TYPE            ENUMERATED (1)
    {
        { 0x00,    "None",         "None" },
        { 0x01,    "Even",         "Even" },
        { 0x02,    "Odd",          "Odd"  }
    }
    HANDLING        READ & WRITE ;
}
VARIABLE    trans1_crc_order
{
    LABEL           "CRC Order" ;
    HELP            "CRC Order" ;
    CLASS           CONTAINED ;
    TYPE            ENUMERATED (1)
    {
        { 0x00,    "Normal",         "Normal" },
        { 0x01,    "Swapped",         "Swapped" }
    }
    HANDLING        READ & WRITE ;
}
VARIABLE    trans1_time_out
{
    LABEL           "Time Out" ;
    HELP            "Time Out" ;
    CLASS           CONTAINED ;
    TYPE            UNSIGNED_INTEGER (2) 
    {
        DEFAULT_VALUE    300;
    }
    HANDLING        READ & WRITE ;
    CONSTANT_UNIT   "ms" ;    
}
VARIABLE    trans1_number_of_retry
{
    LABEL           "Number Of Retry" ;
    HELP            "Number Of Retry" ;
    CLASS           CONTAINED ;
    TYPE            UNSIGNED_INTEGER (1) ;
    HANDLING        READ & WRITE ;
}
VARIABLE    trans1_slave_address_1
{
    LABEL           "Slave Address 1" ;
    HELP            "Slave Address 1 controls 4 channels: Mod_In1, Mod_Out1, Mod_In_D1 and Mod_Out_D1." ;
    CLASS           CONTAINED ;
    TYPE            UNSIGNED_INTEGER (1)
    {
        DEFAULT_VALUE    1;
    }
    POST_EDIT_ACTIONS
    {
        method_set_slave_address_1
    }
    HANDLING        READ & WRITE ;
}
VARIABLE    trans1_slave_address_2
{
    LABEL           "Slave Address 2" ;
    HELP            "Slave Address 2 controls 4 channels: Mod_In2, Mod_Out2, Mod_In_D2 and Mod_Out_D2." ;
    CLASS           CONTAINED ;
    TYPE            UNSIGNED_INTEGER (1)
    {
        DEFAULT_VALUE    2;
    }
    POST_EDIT_ACTIONS
    {
        method_set_slave_address_2
    }
    HANDLING        READ & WRITE ;
}
VARIABLE    trans1_slave_address_3
{
    LABEL           "Slave Address 3" ;
    HELP            "Slave Address 3 controls 4 channels: Mod_In3, Mod_Out3, Mod_In_D3 and Mod_Out_D3." ;
    CLASS           CONTAINED ;
    TYPE            UNSIGNED_INTEGER (1)
    {
        DEFAULT_VALUE    3;
    }
    POST_WRITE_ACTIONS
    {
        method_set_slave_address_3
    }
    HANDLING        READ & WRITE ;
}
VARIABLE    trans1_slave_address_4
{
    LABEL           "Slave Address 4" ;
    HELP            "Slave Address 4 controls 4 channels: Mod_In4, Mod_Out4, Mod_In_D4 and Mod_Out_D4." ;
    CLASS           CONTAINED ;
    TYPE            UNSIGNED_INTEGER (1)
    {
        DEFAULT_VALUE    4;
    }
    POST_EDIT_ACTIONS
    {
        method_set_slave_address_4
    }
    HANDLING        READ & WRITE ;
}
VARIABLE    trans1_bad_status
{
    LABEL           "Bad Status" ;
    HELP            "Bad Status" ;
    CLASS           CONTAINED & DYNAMIC;
    TYPE            BIT_ENUMERATED (4)
    {
        { 0x01000000, "Mod_In1",    "Mod_In1 has bad status" },
        { 0x02000000, "Mod_In2",    "Mod_In2 has bad status" },
        { 0x04000000, "Mod_In3",    "Mod_In3 has bad status" },
        { 0x08000000, "Mod_In4",    "Mod_In4 has bad status" },
        /*
        { 0x10000000, "Mod_In5",    "Mod_In5 has bad status" },
        { 0x20000000, "Mod_In6",    "Mod_In6 has bad status" },
        { 0x40000000, "Mod_In7",    "Mod_In7 has bad status" },
        { 0x80000000, "Mod_In8",    "Mod_In8 has bad status" },
        */
        { 0x00010000, "Mod_Out1",    "Mod_Out1 has bad status" },
        { 0x00020000, "Mod_Out2",    "Mod_Out2 has bad status" },
        { 0x00040000, "Mod_Out3",    "Mod_Out3 has bad status" },
        { 0x00080000, "Mod_Out4",    "Mod_Out4 has bad status" },
        /*          
        { 0x00100000, "Mod_Out5",    "Mod_Out5 has bad status" },
        { 0x00200000, "Mod_Out6",    "Mod_Out6 has bad status" },
        { 0x00400000, "Mod_Out7",    "Mod_Out7 has bad status" },
        { 0x00800000, "Mod_Out8",    "Mod_Out8 has bad status" },
        */
        { 0x00000100, "Mod_In_D1",    "Mod_In_D1 has bad status" },
        { 0x00000200, "Mod_In_D2",    "Mod_In_D2 has bad status" },
        { 0x00000400, "Mod_In_D3",    "Mod_In_D3 has bad status" },
        { 0x00000800, "Mod_In_D4",    "Mod_In_D4 has bad status" },
        /*          
        { 0x00001000, "Mod_In_D5",    "Mod_In_D5 has bad status" },
        { 0x00002000, "Mod_In_D6",    "Mod_In_D6 has bad status" },
        { 0x00004000, "Mod_In_D7",    "Mod_In_D7 has bad status" },
        { 0x00008000, "Mod_In_D8",    "Mod_In_D8 has bad status" },
        */
        { 0x00000001, "Mod_Out_D1",    "Mod_Out_D1 has bad status" },
        { 0x00000002, "Mod_Out_D2",    "Mod_Out_D2 has bad status" },
        { 0x00000004, "Mod_Out_D3",    "Mod_Out_D3 has bad status" },
        { 0x00000008, "Mod_Out_D4",    "Mod_Out_D4 has bad status" }
        /*
        { 0x00000010, "Mod_Out_D5",    "Mod_Out_D5 has bad status" },
        { 0x00000020, "Mod_Out_D6",    "Mod_Out_D6 has bad status" },
        { 0x00000040, "Mod_Out_D7",    "Mod_Out_D7 has bad status" },
        { 0x00000080, "Mod_Out_D8",    "Mod_Out_D8 has bad status" }
        */
    }
    HANDLING        READ;
    STYLE      "MULTILINE 10 16" ;
}
VARIABLE    trans1_err_look_sel
{
    LABEL           "Err Look Sel" ;
    HELP            "Err Look Sel" ;
    CLASS           CONTAINED & DYNAMIC;
    TYPE            ENUMERATED (1)
    {
        { 0,  "Mod_In1",      "Mod_In1" },
        { 1,  "Mod_In2",      "Mod_In2" },
        { 2,  "Mod_In3",      "Mod_In3" },
        { 3,  "Mod_In4",      "Mod_In4" },
        { 4,  "Mod_Out1",     "Mod_Out1" },
        { 5,  "Mod_Out2",     "Mod_Out2" },
        { 6,  "Mod_Out3",     "Mod_Out3" },
        { 7,  "Mod_Out4",     "Mod_Out4" },
        { 8,  "Mod_In_D1",    "Mod_In_D1" },
        { 9,  "Mod_In_D2",    "Mod_In_D2" },
        { 10, "Mod_In_D3",    "Mod_In_D3" },
        { 11, "Mod_In_D4",    "Mod_In_D4" },
        { 12, "Mod_Out_D1",   "Mod_Out_D1" },
        { 13, "Mod_Out_D2",   "Mod_Out_D2" },
        { 14, "Mod_Out_D3",   "Mod_Out_D3" },
        { 15, "Mod_Out_D4",   "Mod_Out_D4" }
    }
    HANDLING        READ & WRITE ;
}
VARIABLE    trans1_err_look_result
{
    LABEL           "Err Look Result" ;
    HELP            "Err Look Result" ;
    CLASS           CONTAINED & DYNAMIC;
    TYPE            ENUMERATED (1)
    {
        { 0x00, "Ok"                                      ,    "Ok"                                                     },
        { 0x01, "Illegal Function"                        ,    "Illegal Function"                                       },
        { 0x02, "Illegal Data Address"                    ,    "Illegal Data Address"                                   },
        { 0x03, "Illegal Data Value"                      ,    "Illegal Data Value"                                     },
        { 0x04, "Slave Device Failure"                    ,    "Slave Device Failure"                                   },
        { 0x05, "Acknowledge"                             ,    "Acknowledge"                                            },
        { 0x06, "Slave Device Busy"                       ,    "Slave Device Busy"                                      },
        { 0x08, "Memory Parity Error"                     ,    "Memory Parity Error"                                    },
        { 0x0A, "Gateway Path Unavailable"                ,    "Gateway Path Unavailable"                               },
        { 0x0B, "Gateway Target Device Failed To Response",    "Gateway Target Device Failed To Response"               },
        { 0xFD, "Data Type Mismatch"                      ,    "Data Type selected cannot be used by this variable"     },
        { 0xFE, "Function Code Mismatch"                  ,    "Function Code selected cannot be used by this variable" },
        { 0xFF, "Comm Failure"                            ,    "Communication Failure on Modbus"                        }
    }
    HANDLING        READ;
}
VARIABLE trans1_mod_in1_value
{
    LABEL       "Mod_In1" ;
    HELP        "Modbus Analog Input 1";
    CLASS       CONTAINED & DYNAMIC;
    TYPE        FLOAT;
    HANDLING    READ;
}

VARIABLE trans1_mod_in1_status_quality
{
    LABEL       [status_quality];
    HELP        [value_status_help];
    CLASS       CONTAINED & DYNAMIC;
    TYPE        ENUMERATED (1)
    {
        DEFAULT_VALUE    0;
        STATUS_OUTPUT_NO_RCAS
    }
    HANDLING    READ;
}

trans1_mod_in1_status_limit            LIKE VARIABLE    trans1_mod_in1_status_quality
{
    REDEFINE LABEL       [status_limit];        
    REDEFINE TYPE        ENUMERATED (1)
    {
        STATUS_OUTPUT_LIMIT
    }
}
VARIABLE trans1_mod_in2_value
{
    LABEL       "Mod_In2" ;
    HELP        "Modbus Analog Input 2";
    CLASS       CONTAINED & DYNAMIC;
    TYPE        FLOAT;
    HANDLING    READ;
}

VARIABLE trans1_mod_in2_status_quality
{
    LABEL       [status_quality];
    HELP        [value_status_help];
    CLASS       CONTAINED & DYNAMIC;
    TYPE        ENUMERATED (1)
    {
        DEFAULT_VALUE    0;
        STATUS_OUTPUT_NO_RCAS
    }
    HANDLING    READ;
}

trans1_mod_in2_status_limit            LIKE VARIABLE    trans1_mod_in2_status_quality
{
    REDEFINE LABEL       [status_limit];        
    REDEFINE TYPE        ENUMERATED (1)
    {
        STATUS_OUTPUT_LIMIT
    }
}
VARIABLE trans1_mod_in3_value
{
    LABEL       "Mod_In3" ;
    HELP        "Modbus Analog Input 3";
    CLASS       CONTAINED & DYNAMIC;
    TYPE        FLOAT;
    HANDLING    READ;
}

VARIABLE trans1_mod_in3_status_quality
{
    LABEL       [status_quality];
    HELP        [value_status_help];
    CLASS       CONTAINED & DYNAMIC;
    TYPE        ENUMERATED (1)
    {
        DEFAULT_VALUE    0;
        STATUS_OUTPUT_NO_RCAS
    }
    HANDLING    READ;
}

trans1_mod_in3_status_limit            LIKE VARIABLE    trans1_mod_in3_status_quality
{
    REDEFINE LABEL       [status_limit];        
    REDEFINE TYPE        ENUMERATED (1)
    {
        STATUS_OUTPUT_LIMIT
    }
}
VARIABLE trans1_mod_in4_value
{
    LABEL       "Mod_In4" ;
    HELP        "Modbus Analog Input 2";
    CLASS       CONTAINED & DYNAMIC;
    TYPE        FLOAT;
    HANDLING    READ;
}

VARIABLE trans1_mod_in4_status_quality
{
    LABEL       [status_quality];
    HELP        [value_status_help];
    CLASS       CONTAINED & DYNAMIC;
    TYPE        ENUMERATED (1)
    {
        DEFAULT_VALUE    0;
        STATUS_OUTPUT_NO_RCAS
    }
    HANDLING    READ;
}

trans1_mod_in4_status_limit            LIKE VARIABLE    trans1_mod_in4_status_quality
{
    REDEFINE LABEL       [status_limit];        
    REDEFINE TYPE        ENUMERATED (1)
    {
        STATUS_OUTPUT_LIMIT
    }
}
VARIABLE trans1_mod_out1_value
{
    LABEL       "Mod_Out1" ;
    HELP        "Modbus Analog Output 1";
    CLASS       CONTAINED & DYNAMIC;
    TYPE        FLOAT;
    HANDLING    READ;
}

VARIABLE trans1_mod_out1_status_quality
{
    LABEL       [status_quality];
    HELP        [value_status_help];
    CLASS       CONTAINED & DYNAMIC;
    TYPE        ENUMERATED (1)
    {
        DEFAULT_VALUE    0;
        STATUS_OUTPUT_NO_RCAS
    }
    HANDLING    READ;
}

trans1_mod_out1_status_limit            LIKE VARIABLE    trans1_mod_out1_status_quality
{
    REDEFINE LABEL       [status_limit];        
    REDEFINE TYPE        ENUMERATED (1)
    {
        STATUS_OUTPUT_LIMIT
    }
}
VARIABLE trans1_mod_out2_value
{
    LABEL       "Mod_Out2" ;
    HELP        "Modbus Analog Output 2";
    CLASS       CONTAINED & DYNAMIC;
    TYPE        FLOAT;
    HANDLING    READ;
}

VARIABLE trans1_mod_out2_status_quality
{
    LABEL       [status_quality];
    HELP        [value_status_help];
    CLASS       CONTAINED & DYNAMIC;
    TYPE        ENUMERATED (1)
    {
        DEFAULT_VALUE    0;
        STATUS_OUTPUT_NO_RCAS
    }
    HANDLING    READ;
}

trans1_mod_out2_status_limit            LIKE VARIABLE    trans1_mod_out1_status_quality
{
    REDEFINE LABEL       [status_limit];        
    REDEFINE TYPE        ENUMERATED (1)
    {
        STATUS_OUTPUT_LIMIT
    }
}
VARIABLE trans1_mod_out3_value
{
    LABEL       "Mod_Out3" ;
    HELP        "Modbus Analog Output 3";
    CLASS       CONTAINED & DYNAMIC;
    TYPE        FLOAT;
    HANDLING    READ;
}

VARIABLE trans1_mod_out3_status_quality
{
    LABEL       [status_quality];
    HELP        [value_status_help];
    CLASS       CONTAINED & DYNAMIC;
    TYPE        ENUMERATED (1)
    {
        DEFAULT_VALUE    0;
        STATUS_OUTPUT_NO_RCAS
    }
    HANDLING    READ;
}

trans1_mod_out3_status_limit            LIKE VARIABLE    trans1_mod_out1_status_quality
{
    REDEFINE LABEL       [status_limit];        
    REDEFINE TYPE        ENUMERATED (1)
    {
        STATUS_OUTPUT_LIMIT
    }
}
VARIABLE trans1_mod_out4_value
{
    LABEL       "Mod_Out4" ;
    HELP        "Modbus Analog Output 4";
    CLASS       CONTAINED & DYNAMIC;
    TYPE        FLOAT;
    HANDLING    READ;
}

VARIABLE trans1_mod_out4_status_quality
{
    LABEL       [status_quality];
    HELP        [value_status_help];
    CLASS       CONTAINED & DYNAMIC;
    TYPE        ENUMERATED (1)
    {
        DEFAULT_VALUE    0;
        STATUS_OUTPUT_NO_RCAS
    }
    HANDLING    READ;
}

trans1_mod_out4_status_limit            LIKE VARIABLE    trans1_mod_out4_status_quality
{
    REDEFINE LABEL       [status_limit];        
    REDEFINE TYPE        ENUMERATED (1)
    {
        STATUS_OUTPUT_LIMIT
    }
}
VARIABLE trans1_mod_in_d1_value
{
    LABEL       "Mod_In_D1" ;
    HELP        "Modbus Discrete Input 1";
    CLASS       CONTAINED & DYNAMIC;
    TYPE        UNSIGNED_INTEGER (1) ;
    HANDLING    READ;
}

VARIABLE trans1_mod_in_d1_status_quality
{
    LABEL       [status_quality];
    HELP        [value_status_help];
    CLASS       CONTAINED & DYNAMIC;
    TYPE        ENUMERATED (1)
    {
        DEFAULT_VALUE    0;
        STATUS_OUTPUT_NO_RCAS
    }
    HANDLING    READ;
}

trans1_mod_in_d1_status_limit            LIKE VARIABLE    trans1_mod_in_d1_status_quality
{
    REDEFINE LABEL       [status_limit];        
    REDEFINE TYPE        ENUMERATED (1)
    {
        STATUS_OUTPUT_LIMIT
    }
}
VARIABLE trans1_mod_in_d2_value
{
    LABEL       "Mod_In_D2" ;
    HELP        "Modbus Discrete Input 2";
    CLASS       CONTAINED & DYNAMIC;
    TYPE        UNSIGNED_INTEGER (1) ;
    HANDLING    READ;
}

VARIABLE trans1_mod_in_d2_status_quality
{
    LABEL       [status_quality];
    HELP        [value_status_help];
    CLASS       CONTAINED & DYNAMIC;
    TYPE        ENUMERATED (1)
    {
        DEFAULT_VALUE    0;
        STATUS_OUTPUT_NO_RCAS
    }
    HANDLING    READ;
}

trans1_mod_in_d2_status_limit            LIKE VARIABLE    trans1_mod_in_d1_status_quality
{
    REDEFINE LABEL       [status_limit];        
    REDEFINE TYPE        ENUMERATED (1)
    {
        STATUS_OUTPUT_LIMIT
    }
}
VARIABLE trans1_mod_in_d3_value
{
    LABEL       "Mod_In_D3" ;
    HELP        "Modbus Discrete Input 3";
    CLASS       CONTAINED & DYNAMIC;
    TYPE        UNSIGNED_INTEGER (1) ;
    HANDLING    READ;
}

VARIABLE trans1_mod_in_d3_status_quality
{
    LABEL       [status_quality];
    HELP        [value_status_help];
    CLASS       CONTAINED & DYNAMIC;
    TYPE        ENUMERATED (1)
    {
        DEFAULT_VALUE    0;
        STATUS_OUTPUT_NO_RCAS
    }
    HANDLING    READ;
}

trans1_mod_in_d3_status_limit            LIKE VARIABLE    trans1_mod_in_d3_status_quality
{
    REDEFINE LABEL       [status_limit];        
    REDEFINE TYPE        ENUMERATED (1)
    {
        STATUS_OUTPUT_LIMIT
    }
}
VARIABLE trans1_mod_in_d4_value
{
    LABEL       "Mod_In_D4" ;
    HELP        "Modbus Discrete Input 4";
    CLASS       CONTAINED & DYNAMIC;
    TYPE        UNSIGNED_INTEGER (1) ;
    HANDLING    READ;
}

VARIABLE trans1_mod_in_d4_status_quality
{
    LABEL       [status_quality];
    HELP        [value_status_help];
    CLASS       CONTAINED & DYNAMIC;
    TYPE        ENUMERATED (1)
    {
        DEFAULT_VALUE    0;
        STATUS_OUTPUT_NO_RCAS
    }
    HANDLING    READ;
}

trans1_mod_in_d4_status_limit            LIKE VARIABLE    trans1_mod_in_d4_status_quality
{
    REDEFINE LABEL       [status_limit];        
    REDEFINE TYPE        ENUMERATED (1)
    {
        STATUS_OUTPUT_LIMIT
    }
}

VARIABLE trans1_mod_out_d1_value
{
    LABEL       "Mod_Out_D1" ;
    HELP        "Modbus Discrete Output 1";
    CLASS       CONTAINED & DYNAMIC;
    TYPE        UNSIGNED_INTEGER (1) ;
    HANDLING    READ;
}

VARIABLE trans1_mod_out_d1_status_quality
{
    LABEL       [status_quality];
    HELP        [value_status_help];
    CLASS       CONTAINED & DYNAMIC;
    TYPE        ENUMERATED (1)
    {
        DEFAULT_VALUE    0;
        STATUS_OUTPUT_NO_RCAS
    }
    HANDLING    READ;
}

trans1_mod_out_d1_status_limit            LIKE VARIABLE    trans1_mod_out_d1_status_quality
{
    REDEFINE LABEL       [status_limit];        
    REDEFINE TYPE        ENUMERATED (1)
    {
        STATUS_OUTPUT_LIMIT
    }
}
VARIABLE trans1_mod_out_d2_value
{
    LABEL       "Mod_Out_D2" ;
    HELP        "Modbus Discrete Output 2";
    CLASS       CONTAINED & DYNAMIC;
    TYPE        UNSIGNED_INTEGER (1) ;
    HANDLING    READ;
}

VARIABLE trans1_mod_out_d2_status_quality
{
    LABEL       [status_quality];
    HELP        [value_status_help];
    CLASS       CONTAINED & DYNAMIC;
    TYPE        ENUMERATED (1)
    {
        DEFAULT_VALUE    0;
        STATUS_OUTPUT_NO_RCAS
    }
    HANDLING    READ;
}

trans1_mod_out_d2_status_limit            LIKE VARIABLE    trans1_mod_out_d1_status_quality
{
    REDEFINE LABEL       [status_limit];        
    REDEFINE TYPE        ENUMERATED (1)
    {
        STATUS_OUTPUT_LIMIT
    }
}
VARIABLE trans1_mod_out_d3_value
{
    LABEL       "Mod_Out_D3" ;
    HELP        "Modbus Discrete Output 3";
    CLASS       CONTAINED & DYNAMIC;
    TYPE        UNSIGNED_INTEGER (1) ;
    HANDLING    READ;
}

VARIABLE trans1_mod_out_d3_status_quality
{
    LABEL       [status_quality];
    HELP        [value_status_help];
    CLASS       CONTAINED & DYNAMIC;
    TYPE        ENUMERATED (1)
    {
        DEFAULT_VALUE    0;
        STATUS_OUTPUT_NO_RCAS
    }
    HANDLING    READ;
}

trans1_mod_out_d3_status_limit            LIKE VARIABLE    trans1_mod_out_d3_status_quality
{
    REDEFINE LABEL       [status_limit];        
    REDEFINE TYPE        ENUMERATED (1)
    {
        STATUS_OUTPUT_LIMIT
    }
}
VARIABLE trans1_mod_out_d4_value
{
    LABEL       "Mod_Out_D4" ;
    HELP        "Modbus Discrete Output 4";
    CLASS       CONTAINED & DYNAMIC;
    TYPE        UNSIGNED_INTEGER (1) ;
    HANDLING    READ;
}

VARIABLE trans1_mod_out_d4_status_quality
{
    LABEL       [status_quality];
    HELP        [value_status_help];
    CLASS       CONTAINED & DYNAMIC;
    TYPE        ENUMERATED (1)
    {
        DEFAULT_VALUE    0;
        STATUS_OUTPUT_NO_RCAS
    }
    HANDLING    READ;
}

trans1_mod_out_d4_status_limit            LIKE VARIABLE    trans1_mod_out_d4_status_quality
{
    REDEFINE LABEL       [status_limit];        
    REDEFINE TYPE        ENUMERATED (1)
    {
        STATUS_OUTPUT_LIMIT
    }
}

VARIABLE    trans1_scale_loc_in1_from_eu_0
{
    LABEL           "From EU at 0%" ;
    HELP            "From EU at 0%" ;
    CLASS           CONTAINED ;
    TYPE            FLOAT
    {
        DEFAULT_VALUE    0.0;
    }
    HANDLING        READ & WRITE ;
}
VARIABLE    trans1_scale_loc_in1_from_eu_100
{
    LABEL           "From EU at 100%" ;
    HELP            "From EU at 100%" ;
    CLASS           CONTAINED ;
    TYPE            FLOAT
    {
        DEFAULT_VALUE    100.0;
    }
    HANDLING        READ & WRITE ;
}
VARIABLE    trans1_scale_loc_in1_to_eu_0
{
    LABEL           "To EU at 0%" ;
    HELP            "To EU at 0%" ;
    CLASS           CONTAINED ;
    TYPE            FLOAT
    {
        DEFAULT_VALUE    0.0;
    }
    HANDLING        READ & WRITE ;
}
VARIABLE    trans1_scale_loc_in1_to_eu_100
{
    LABEL           "To EU at 100%" ;
    HELP            "To EU at 100%" ;
    CLASS           CONTAINED ;
    TYPE            FLOAT
    {
        DEFAULT_VALUE    100.0;
    }
    HANDLING        READ & WRITE ;
}
VARIABLE    trans1_scale_loc_in1_data_type
{
    LABEL           "Data Type" ;
    HELP            "Data Type" ;
    CLASS           CONTAINED ;
    TYPE            ENUMERATED (1)
    {
        { 1 ,    "Float_0123",         "Float_0123"      },
        { 2 ,    "Float_1032",         "Float_1032"      },
        { 3 ,    "Float_3210",         "Float_3210"      },
        { 4 ,    "Float_2301",         "Float_2301"      },
        { 5 ,    "Unsigned8_0",        "Unsigned8_0"     },
        { 6 ,    "Unsigned8_1",        "Unsigned8_1"     },
        { 7 ,    "Unsigned16_01",      "Unsigned16_01"   },
        { 8 ,    "Unsigned16_10",      "Unsigned16_10"   },
        { 9 ,    "Unsigned32_0123",    "Unsigned32_0123" },
        { 10,    "Unsigned32_1032",    "Unsigned32_1032" },
        { 11,    "Unsigned32_3210",    "Unsigned32_3210" },
        { 12,    "Unsigned32_2301",    "Unsigned32_2301" },
        { 13,    "Signed8_0",          "Signed8_0"       },
        { 14,    "Signed8_1",          "Signed8_1"       },
        { 15,    "Signed16_01",        "Signed16_01"     },
        { 16,    "Signed16_10",        "Signed16_10"     },
        { 17,    "Signed32_0123",      "Signed32_0123"   },
        { 18,    "Signed32_1032",      "Signed32_1032"   },
        { 19,    "Signed32_3210",      "Signed32_3210"   },
        { 20,    "Signed32_2301",      "Signed32_2301"   }
    }
    HANDLING        READ & WRITE ;
}
VARIABLE    trans1_scale_loc_in1_slave_address
{
    LABEL           "Slave Address" ;
    HELP            "Slave Address" ;
    CLASS           CONTAINED ;
    TYPE            UNSIGNED_INTEGER (1) ;
    HANDLING        READ & WRITE ;
}
VARIABLE    trans1_scale_loc_in1_function_code
{
    LABEL           "Function Code" ;
    HELP            "Function Code" ;
    CLASS           CONTAINED ;
    TYPE            ENUMERATED (1)
    {
        { 0x00,    "No Command",                       "No Command"                   },
        { 0x03,    "FC03 Read Holding Register",       "FC03 Read Holding Register"   },
        { 0x04,    "FC04 Read Input Register",         "FC04 Read Input Register"     }
    }
    HANDLING        READ & WRITE ;
}
VARIABLE    trans1_scale_loc_in1_reg_addr_of_value
{
    LABEL           "Register Addr Of Value" ;
    HELP            "Register Addr Of Value" ;
    CLASS           CONTAINED ;
    TYPE            UNSIGNED_INTEGER (2)    
    {
        DEFAULT_VALUE    0;
    }
    HANDLING        READ & WRITE ;
}
VARIABLE    trans1_scale_loc_in1_reg_addr_of_status
{
    LABEL           "Register Addr Of Status" ;
    HELP            "Register Addr Of Status" ;
    CLASS           CONTAINED ;
    TYPE            UNSIGNED_INTEGER (2)    
    {
        DEFAULT_VALUE    0;
    }
    HANDLING        READ & WRITE ;
}
trans1_scale_loc_in2_from_eu_0          LIKE VARIABLE trans1_scale_loc_in1_from_eu_0
{
}
trans1_scale_loc_in2_from_eu_100        LIKE VARIABLE trans1_scale_loc_in1_from_eu_100
{
}
trans1_scale_loc_in2_to_eu_0            LIKE VARIABLE trans1_scale_loc_in1_to_eu_0
{
}
trans1_scale_loc_in2_to_eu_100          LIKE VARIABLE trans1_scale_loc_in1_to_eu_100
{
}
trans1_scale_loc_in2_data_type          LIKE VARIABLE trans1_scale_loc_in1_data_type
{
}
trans1_scale_loc_in2_slave_address      LIKE VARIABLE trans1_scale_loc_in1_slave_address
{
}
trans1_scale_loc_in2_function_code      LIKE VARIABLE trans1_scale_loc_in1_function_code
{
}
trans1_scale_loc_in2_reg_addr_of_value      LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_value
{
}
trans1_scale_loc_in2_reg_addr_of_status     LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_status
{
}
trans1_scale_loc_in3_from_eu_0          LIKE VARIABLE trans1_scale_loc_in1_from_eu_0
{
}
trans1_scale_loc_in3_from_eu_100        LIKE VARIABLE trans1_scale_loc_in1_from_eu_100
{
}
trans1_scale_loc_in3_to_eu_0            LIKE VARIABLE trans1_scale_loc_in1_to_eu_0
{
}
trans1_scale_loc_in3_to_eu_100          LIKE VARIABLE trans1_scale_loc_in1_to_eu_100
{
}
trans1_scale_loc_in3_data_type          LIKE VARIABLE trans1_scale_loc_in1_data_type
{
}
trans1_scale_loc_in3_slave_address      LIKE VARIABLE trans1_scale_loc_in1_slave_address
{
}
trans1_scale_loc_in3_function_code      LIKE VARIABLE trans1_scale_loc_in1_function_code
{
}
trans1_scale_loc_in3_reg_addr_of_value      LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_value
{
}
trans1_scale_loc_in3_reg_addr_of_status     LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_status
{
}
trans1_scale_loc_in4_from_eu_0          LIKE VARIABLE trans1_scale_loc_in1_from_eu_0
{
}
trans1_scale_loc_in4_from_eu_100        LIKE VARIABLE trans1_scale_loc_in1_from_eu_100
{
}
trans1_scale_loc_in4_to_eu_0            LIKE VARIABLE trans1_scale_loc_in1_to_eu_0
{
}
trans1_scale_loc_in4_to_eu_100          LIKE VARIABLE trans1_scale_loc_in1_to_eu_100
{
}
trans1_scale_loc_in4_data_type          LIKE VARIABLE trans1_scale_loc_in1_data_type
{
}
trans1_scale_loc_in4_slave_address      LIKE VARIABLE trans1_scale_loc_in1_slave_address
{
}
trans1_scale_loc_in4_function_code      LIKE VARIABLE trans1_scale_loc_in1_function_code
{
}
trans1_scale_loc_in4_reg_addr_of_value      LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_value
{
}
trans1_scale_loc_in4_reg_addr_of_status     LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_status
{
}
trans1_scale_loc_out1_from_eu_0          LIKE VARIABLE trans1_scale_loc_in1_from_eu_0
{                                        
}                                        
trans1_scale_loc_out1_from_eu_100        LIKE VARIABLE trans1_scale_loc_in1_from_eu_100
{                                        
}                                        
trans1_scale_loc_out1_to_eu_0            LIKE VARIABLE trans1_scale_loc_in1_to_eu_0
{                                        
}                                        
trans1_scale_loc_out1_to_eu_100          LIKE VARIABLE trans1_scale_loc_in1_to_eu_100
{                                        
}                                        
trans1_scale_loc_out1_data_type          LIKE VARIABLE trans1_scale_loc_in1_data_type
{
}                                        
trans1_scale_loc_out1_slave_address      LIKE VARIABLE trans1_scale_loc_in1_slave_address
{
}
trans1_scale_loc_out1_function_code      LIKE VARIABLE trans1_scale_loc_in1_function_code
{
    REDEFINE TYPE        ENUMERATED (1)
    {
        { 0x00,    "No Command",                       "No Command"                   },
        { 0x06,    "FC06 Write Single Register",       "FC06 Write Single Register"   },
        { 0x10,    "FC16 Write Multiple Register",     "FC16 Write Multiple Register" }
    }
}
trans1_scale_loc_out1_reg_addr_of_value      LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_value
{                                        
}                                        
trans1_scale_loc_out1_reg_addr_of_status     LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_status
{                                        
}                                        
trans1_scale_loc_out2_from_eu_0          LIKE VARIABLE trans1_scale_loc_in1_from_eu_0
{                                        
}                                        
trans1_scale_loc_out2_from_eu_100        LIKE VARIABLE trans1_scale_loc_in1_from_eu_100
{                                        
}                                        
trans1_scale_loc_out2_to_eu_0            LIKE VARIABLE trans1_scale_loc_in1_to_eu_0
{                                        
}                                        
trans1_scale_loc_out2_to_eu_100          LIKE VARIABLE trans1_scale_loc_in1_to_eu_100
{                                        
}                                        
trans1_scale_loc_out2_data_type          LIKE VARIABLE trans1_scale_loc_out1_data_type
{                                        
}                                        
trans1_scale_loc_out2_slave_address      LIKE VARIABLE trans1_scale_loc_in1_slave_address
{
}
trans1_scale_loc_out2_function_code      LIKE VARIABLE trans1_scale_loc_out1_function_code
{                                        
}                                        
trans1_scale_loc_out2_reg_addr_of_value      LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_value
{                                        
}                                        
trans1_scale_loc_out2_reg_addr_of_status     LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_status
{                                        
}                                        
trans1_scale_loc_out3_from_eu_0          LIKE VARIABLE trans1_scale_loc_in1_from_eu_0
{                                        
}                                        
trans1_scale_loc_out3_from_eu_100        LIKE VARIABLE trans1_scale_loc_in1_from_eu_100
{                                        
}                                        
trans1_scale_loc_out3_to_eu_0            LIKE VARIABLE trans1_scale_loc_in1_to_eu_0
{                                        
}                                        
trans1_scale_loc_out3_to_eu_100          LIKE VARIABLE trans1_scale_loc_in1_to_eu_100
{                                        
}                                        
trans1_scale_loc_out3_data_type          LIKE VARIABLE trans1_scale_loc_out1_data_type
{                                        
}                                        
trans1_scale_loc_out3_slave_address      LIKE VARIABLE trans1_scale_loc_in1_slave_address
{
}
trans1_scale_loc_out3_function_code      LIKE VARIABLE trans1_scale_loc_out1_function_code
{                                        
}                                        
trans1_scale_loc_out3_reg_addr_of_value      LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_value
{                                        
}                                        
trans1_scale_loc_out3_reg_addr_of_status     LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_status
{                                        
}                                        
trans1_scale_loc_out4_from_eu_0          LIKE VARIABLE trans1_scale_loc_in1_from_eu_0
{                                        
}                                        
trans1_scale_loc_out4_from_eu_100        LIKE VARIABLE trans1_scale_loc_in1_from_eu_100
{                                        
}                                        
trans1_scale_loc_out4_to_eu_0            LIKE VARIABLE trans1_scale_loc_in1_to_eu_0
{                                        
}                                        
trans1_scale_loc_out4_to_eu_100          LIKE VARIABLE trans1_scale_loc_in1_to_eu_100
{                                        
}                                        
trans1_scale_loc_out4_data_type          LIKE VARIABLE trans1_scale_loc_out1_data_type
{                                        
}                                        
trans1_scale_loc_out4_slave_address      LIKE VARIABLE trans1_scale_loc_in1_slave_address
{
}
trans1_scale_loc_out4_function_code      LIKE VARIABLE trans1_scale_loc_out1_function_code
{                                        
}                                        
trans1_scale_loc_out4_reg_addr_of_value      LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_value
{                                        
}                                        
trans1_scale_loc_out4_reg_addr_of_status     LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_status
{
}
trans1_loc_in_d1_data_type          LIKE VARIABLE trans1_scale_loc_in1_data_type
{
    REDEFINE TYPE        ENUMERATED (1)
    {
        { 5 ,    "Unsigned8_0",        "Unsigned8_0"     },
        { 6 ,    "Unsigned8_1",        "Unsigned8_1"     }
    }
}
trans1_loc_in_d1_slave_address      LIKE VARIABLE trans1_scale_loc_in1_slave_address
{
}
trans1_loc_in_d1_function_code      LIKE VARIABLE trans1_scale_loc_in1_function_code
{
    REDEFINE TYPE        ENUMERATED (1)
    {
        { 0x00,    "No Command",                       "No Command"                   },
        { 0x01,    "FC01 Read Coils",                  "FC01 Read Coils"              },
        { 0x02,    "FC02 Read Discrete Input",         "FC02 Read Discrete Input"     },
        { 0x03,    "FC03 Read Holding Register",       "FC03 Read Holding Register"   },
        { 0x04,    "FC04 Read Input Register",         "FC04 Read Input Register"     }
    }
}
trans1_loc_in_d1_reg_addr_of_value      LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_value
{
}
trans1_loc_in_d1_reg_addr_of_status     LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_status
{
}
trans1_loc_in_d2_data_type          LIKE VARIABLE trans1_loc_in_d1_data_type
{
}
trans1_loc_in_d2_slave_address      LIKE VARIABLE trans1_scale_loc_in1_slave_address
{
}
trans1_loc_in_d2_function_code      LIKE VARIABLE trans1_loc_in_d1_function_code
{
}
trans1_loc_in_d2_reg_addr_of_value      LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_value
{
}
trans1_loc_in_d2_reg_addr_of_status     LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_status
{
}
trans1_loc_in_d3_data_type          LIKE VARIABLE trans1_loc_in_d1_data_type
{
}
trans1_loc_in_d3_slave_address      LIKE VARIABLE trans1_scale_loc_in1_slave_address
{
}
trans1_loc_in_d3_function_code      LIKE VARIABLE trans1_loc_in_d1_function_code
{
}
trans1_loc_in_d3_reg_addr_of_value      LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_value
{
}
trans1_loc_in_d3_reg_addr_of_status     LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_status
{
}
trans1_loc_in_d4_data_type          LIKE VARIABLE trans1_loc_in_d1_data_type
{
}
trans1_loc_in_d4_slave_address      LIKE VARIABLE trans1_scale_loc_in1_slave_address
{
}
trans1_loc_in_d4_function_code      LIKE VARIABLE trans1_loc_in_d1_function_code
{
}
trans1_loc_in_d4_reg_addr_of_value      LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_value
{
}
trans1_loc_in_d4_reg_addr_of_status     LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_status
{
}
trans1_loc_out_d1_data_type          LIKE VARIABLE trans1_loc_in_d1_data_type
{
}
trans1_loc_out_d1_slave_address      LIKE VARIABLE trans1_scale_loc_in1_slave_address
{
}
trans1_loc_out_d1_function_code      LIKE VARIABLE trans1_scale_loc_in1_function_code
{
    REDEFINE TYPE        ENUMERATED (1)
    {
        { 0x00,    "No Command",                       "No Command"                   },
        { 0x05,    "FC05 Write Single Coils",          "FC05 Write Single Coils"      },
        { 0x06,    "FC06 Write Single Register",       "FC06 Write Single Register"   }
    }
}
trans1_loc_out_d1_reg_addr_of_value      LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_value
{
}
trans1_loc_out_d1_reg_addr_of_status     LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_status
{
}
trans1_loc_out_d2_data_type          LIKE VARIABLE trans1_loc_in_d1_data_type
{
}
trans1_loc_out_d2_slave_address      LIKE VARIABLE trans1_scale_loc_in1_slave_address
{
}
trans1_loc_out_d2_function_code      LIKE VARIABLE trans1_loc_out_d1_function_code
{
}
trans1_loc_out_d2_reg_addr_of_value      LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_value
{
}
trans1_loc_out_d2_reg_addr_of_status     LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_status
{
}
trans1_loc_out_d3_data_type          LIKE VARIABLE trans1_loc_in_d1_data_type
{
}
trans1_loc_out_d3_slave_address      LIKE VARIABLE trans1_scale_loc_in1_slave_address
{
}
trans1_loc_out_d3_function_code      LIKE VARIABLE trans1_loc_out_d1_function_code
{
}
trans1_loc_out_d3_reg_addr_of_value      LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_value
{
}
trans1_loc_out_d3_reg_addr_of_status     LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_status
{
}
trans1_loc_out_d4_data_type          LIKE VARIABLE trans1_loc_in_d1_data_type
{
}
trans1_loc_out_d4_slave_address      LIKE VARIABLE trans1_scale_loc_in1_slave_address
{
}
trans1_loc_out_d4_function_code      LIKE VARIABLE trans1_loc_out_d1_function_code
{
}
trans1_loc_out_d4_reg_addr_of_value      LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_value
{
}
trans1_loc_out_d4_reg_addr_of_status     LIKE VARIABLE trans1_scale_loc_in1_reg_addr_of_status
{
}

/*---------------------------------------------------------------------*/
/*    Commands                                                         */
/*---------------------------------------------------------------------*/

COMMAND read_trans1_blk
{
    BLOCK transducer_block_1;
    INDEX 0;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_blk_reserve,
            trans1_blk_object, 
            trans1_blk_parent_class, 
            trans1_blk_class,
            trans1_blk_dd_reference, 
            trans1_blk_dd_rev, 
            trans1_blk_profile, 
            trans1_blk_profile_rev,
            trans1_blk_execution_time, 
            trans1_blk_num_parameters, 
            trans1_blk_index_view_1,
            trans1_blk_num_view_lists
        }
    }
}

COMMAND read_trans1_st_rev
{
    BLOCK transducer_block_1;
    INDEX 1;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_st_rev
        }
    }
}

COMMAND read_trans1_tag_desc
{
    BLOCK transducer_block_1;
    INDEX 2;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_tag_desc
        }
    }
}

COMMAND write_trans1_tag_desc
{
    BLOCK transducer_block_1;
    INDEX 2;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_tag_desc
        }
        REPLY
        {
        }
    }
}

COMMAND read_trans1_strategy
{
    BLOCK transducer_block_1;
    INDEX 3;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_strategy
        }
    }
}

COMMAND write_trans1_strategy
{
    BLOCK transducer_block_1;
    INDEX 3;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_strategy
        }
        REPLY
        {
        }
    }
}

COMMAND read_trans1_alert_key
{
    BLOCK transducer_block_1;
    INDEX 4;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_alert_key
        }
    }
}

COMMAND write_trans1_alert_key
{
    BLOCK transducer_block_1;
    INDEX 4;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_alert_key
        }
        REPLY
        {
        }
    }
}

COMMAND read_trans1_target_mode
{
    BLOCK transducer_block_1;
    INDEX 5;
    OPERATION  READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_target_mode
        }
    }
}

COMMAND write_trans1_target_mode
{
    BLOCK transducer_block_1;
    INDEX 5;
    OPERATION  WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_target_mode
        }
        REPLY
        {
        }
    }
}


COMMAND read_trans1_mode
{
    BLOCK transducer_block_1;
    INDEX 6;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_actual_mode,
            trans1_permitted_mode,
            trans1_normal_mode
        }
    }
}

COMMAND read_trans1_alarm
{
    BLOCK transducer_block_1;
    INDEX 7;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_current_state_alarm_sum, 
            trans1_unacknowledged_state_alarm_sum,
            trans1_unreported_state_alarm_sum, 
            trans1_disabled_state_alarm_sum
        }
    }
}
//
//COMMAND read_trans1_media
//{
//    BLOCK transducer_block_1;
//    INDEX 12;
//    OPERATION READ;
//    TRANSACTION
//    {
//        REQUEST
//        {
//        }
//        REPLY
//        {
//            trans1_media
//        }
//    }
//}
//COMMAND write_trans1_media
//{
//    BLOCK transducer_block_1;
//    INDEX 12;
//    OPERATION WRITE;
//    TRANSACTION
//    {
//        REQUEST
//        {
//            trans1_media
//        }
//        REPLY
//        {
//        }
//    }
//}
COMMAND read_trans1_baud_rate
{
    BLOCK transducer_block_1;
    INDEX 13;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_baud_rate
        }
    }
}
COMMAND write_trans1_baud_rate
{
    BLOCK transducer_block_1;
    INDEX 13;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_baud_rate
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_stop_bits
{
    BLOCK transducer_block_1;
    INDEX 14;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_stop_bits
        }
    }
}
COMMAND write_trans1_stop_bits
{
    BLOCK transducer_block_1;
    INDEX 14;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_stop_bits
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_parity
{
    BLOCK transducer_block_1;
    INDEX 15;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_parity
        }
    }
}
COMMAND write_trans1_parity
{
    BLOCK transducer_block_1;
    INDEX 15;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_parity
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_crc_order
{
    BLOCK transducer_block_1;
    INDEX 16;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_crc_order
        }
    }
}
COMMAND write_trans1_crc_order
{
    BLOCK transducer_block_1;
    INDEX 16;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_crc_order
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_time_out
{
    BLOCK transducer_block_1;
    INDEX 17;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_time_out
        }
    }
}
COMMAND write_trans1_time_out
{
    BLOCK transducer_block_1;
    INDEX 17;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_time_out
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_number_of_retry
{
    BLOCK transducer_block_1;
    INDEX 18;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_number_of_retry
        }
    }
}
COMMAND write_trans1_number_of_retry
{
    BLOCK transducer_block_1;
    INDEX 18;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_number_of_retry
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_slave_address
{
    BLOCK transducer_block_1;
    INDEX 19;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_slave_address_1,
            trans1_slave_address_2,
            trans1_slave_address_3,
            trans1_slave_address_4
        }
    }
}
COMMAND write_trans1_slave_address
{
    BLOCK transducer_block_1;
    INDEX 19;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_slave_address_1,
            trans1_slave_address_2,
            trans1_slave_address_3,
            trans1_slave_address_4
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_bad_status
{
    BLOCK transducer_block_1;
    INDEX 20;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_bad_status
        }
    }
}
COMMAND read_trans1_err_look_sel
{
    BLOCK transducer_block_1;
    INDEX 21;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_err_look_sel
        }
    }
}
COMMAND write_trans1_err_look_sel
{
    BLOCK transducer_block_1;
    INDEX 21;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_err_look_sel
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_err_look_result
{
    BLOCK transducer_block_1;
    INDEX 22;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_err_look_result
        }
    }
}
COMMAND read_trans1_mod_in1
{
    BLOCK transducer_block_1;
    INDEX 23;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_mod_in1_value,
            trans1_mod_in1_status_quality <0xFC>,
            trans1_mod_in1_status_limit   <0x03>
        }
    }
}
COMMAND read_trans1_scale_loc_in1
{
    BLOCK transducer_block_1;
    INDEX 24;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_scale_loc_in1_from_eu_100,
            trans1_scale_loc_in1_from_eu_0,
            trans1_scale_loc_in1_to_eu_100,
            trans1_scale_loc_in1_to_eu_0,
            trans1_scale_loc_in1_data_type,
            trans1_scale_loc_in1_slave_address,
            trans1_scale_loc_in1_function_code,
            trans1_scale_loc_in1_reg_addr_of_value,
            trans1_scale_loc_in1_reg_addr_of_status
        }
    }
}
COMMAND write_trans1_scale_loc_in1
{
    BLOCK transducer_block_1;
    INDEX 24;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_scale_loc_in1_from_eu_100,
            trans1_scale_loc_in1_from_eu_0,
            trans1_scale_loc_in1_to_eu_100,
            trans1_scale_loc_in1_to_eu_0,
            trans1_scale_loc_in1_data_type,
            trans1_scale_loc_in1_slave_address,
            trans1_scale_loc_in1_function_code,
            trans1_scale_loc_in1_reg_addr_of_value,
            trans1_scale_loc_in1_reg_addr_of_status
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_mod_in2
{
    BLOCK transducer_block_1;
    INDEX 25;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_mod_in2_value,
            trans1_mod_in2_status_quality <0xFC>,
            trans1_mod_in2_status_limit   <0x03>
        }
    }
}
COMMAND read_trans1_scale_loc_in2
{
    BLOCK transducer_block_1;
    INDEX 26;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_scale_loc_in2_from_eu_100,
            trans1_scale_loc_in2_from_eu_0,
            trans1_scale_loc_in2_to_eu_100,
            trans1_scale_loc_in2_to_eu_0,
            trans1_scale_loc_in2_data_type,
            trans1_scale_loc_in2_slave_address,
            trans1_scale_loc_in2_function_code,
            trans1_scale_loc_in2_reg_addr_of_value,
            trans1_scale_loc_in2_reg_addr_of_status
        }
    }
}
COMMAND write_trans1_scale_loc_in2
{
    BLOCK transducer_block_1;
    INDEX 26;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_scale_loc_in2_from_eu_100,
            trans1_scale_loc_in2_from_eu_0,
            trans1_scale_loc_in2_to_eu_100,
            trans1_scale_loc_in2_to_eu_0,
            trans1_scale_loc_in2_data_type,
            trans1_scale_loc_in2_slave_address,
            trans1_scale_loc_in2_function_code,
            trans1_scale_loc_in2_reg_addr_of_value,
            trans1_scale_loc_in2_reg_addr_of_status
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_mod_in3
{
    BLOCK transducer_block_1;
    INDEX 27;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_mod_in3_value,
            trans1_mod_in3_status_quality <0xFC>,
            trans1_mod_in3_status_limit   <0x03>
        }
    }
}
COMMAND read_trans1_scale_loc_in3
{
    BLOCK transducer_block_1;
    INDEX 28;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_scale_loc_in3_from_eu_100,
            trans1_scale_loc_in3_from_eu_0,
            trans1_scale_loc_in3_to_eu_100,
            trans1_scale_loc_in3_to_eu_0,
            trans1_scale_loc_in3_data_type,
            trans1_scale_loc_in3_slave_address,
            trans1_scale_loc_in3_function_code,
            trans1_scale_loc_in3_reg_addr_of_value,
            trans1_scale_loc_in3_reg_addr_of_status
        }
    }
}
COMMAND write_trans1_scale_loc_in3
{
    BLOCK transducer_block_1;
    INDEX 28;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_scale_loc_in3_from_eu_100,
            trans1_scale_loc_in3_from_eu_0,
            trans1_scale_loc_in3_to_eu_100,
            trans1_scale_loc_in3_to_eu_0,
            trans1_scale_loc_in3_data_type,
            trans1_scale_loc_in3_slave_address,
            trans1_scale_loc_in3_function_code,
            trans1_scale_loc_in3_reg_addr_of_value,
            trans1_scale_loc_in3_reg_addr_of_status
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_mod_in4
{
    BLOCK transducer_block_1;
    INDEX 29;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_mod_in4_value,
            trans1_mod_in4_status_quality <0xFC>,
            trans1_mod_in4_status_limit   <0x03>
        }
    }
}
COMMAND read_trans1_scale_loc_in4
{
    BLOCK transducer_block_1;
    INDEX 30;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_scale_loc_in4_from_eu_100,
            trans1_scale_loc_in4_from_eu_0,
            trans1_scale_loc_in4_to_eu_100,
            trans1_scale_loc_in4_to_eu_0,
            trans1_scale_loc_in4_data_type,
            trans1_scale_loc_in4_slave_address,
            trans1_scale_loc_in4_function_code,
            trans1_scale_loc_in4_reg_addr_of_value,
            trans1_scale_loc_in4_reg_addr_of_status
        }
    }
}
COMMAND write_trans1_scale_loc_in4
{
    BLOCK transducer_block_1;
    INDEX 30;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_scale_loc_in4_from_eu_100,
            trans1_scale_loc_in4_from_eu_0,
            trans1_scale_loc_in4_to_eu_100,
            trans1_scale_loc_in4_to_eu_0,
            trans1_scale_loc_in4_data_type,
            trans1_scale_loc_in4_slave_address,
            trans1_scale_loc_in4_function_code,
            trans1_scale_loc_in4_reg_addr_of_value,
            trans1_scale_loc_in4_reg_addr_of_status
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_mod_out1
{
    BLOCK transducer_block_1;
    INDEX 31;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_mod_out1_value,
            trans1_mod_out1_status_quality <0xFC>,
            trans1_mod_out1_status_limit   <0x03>
        }
    }
}
COMMAND read_trans1_scale_loc_out1
{
    BLOCK transducer_block_1;
    INDEX 32;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_scale_loc_out1_from_eu_100,
            trans1_scale_loc_out1_from_eu_0,
            trans1_scale_loc_out1_to_eu_100,
            trans1_scale_loc_out1_to_eu_0,
            trans1_scale_loc_out1_data_type,
            trans1_scale_loc_out1_slave_address,
            trans1_scale_loc_out1_function_code,
            trans1_scale_loc_out1_reg_addr_of_value,
            trans1_scale_loc_out1_reg_addr_of_status
        }
    }
}
COMMAND write_trans1_scale_loc_out1
{
    BLOCK transducer_block_1;
    INDEX 32;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_scale_loc_out1_from_eu_100,
            trans1_scale_loc_out1_from_eu_0,
            trans1_scale_loc_out1_to_eu_100,
            trans1_scale_loc_out1_to_eu_0,
            trans1_scale_loc_out1_data_type,
            trans1_scale_loc_out1_slave_address,
            trans1_scale_loc_out1_function_code,
            trans1_scale_loc_out1_reg_addr_of_value,
            trans1_scale_loc_out1_reg_addr_of_status
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_mod_out2
{
    BLOCK transducer_block_1;
    INDEX 33;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_mod_out2_value,
            trans1_mod_out2_status_quality <0xFC>,
            trans1_mod_out2_status_limit   <0x03>
        }
    }
}
COMMAND read_trans1_scale_loc_out2
{
    BLOCK transducer_block_1;
    INDEX 34;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_scale_loc_out2_from_eu_100,
            trans1_scale_loc_out2_from_eu_0,
            trans1_scale_loc_out2_to_eu_100,
            trans1_scale_loc_out2_to_eu_0,
            trans1_scale_loc_out2_data_type,
            trans1_scale_loc_out2_slave_address,
            trans1_scale_loc_out2_function_code,
            trans1_scale_loc_out2_reg_addr_of_value,
            trans1_scale_loc_out2_reg_addr_of_status
        }
    }
}
COMMAND write_trans1_scale_loc_out2
{
    BLOCK transducer_block_1;
    INDEX 34;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_scale_loc_out2_from_eu_100,
            trans1_scale_loc_out2_from_eu_0,
            trans1_scale_loc_out2_to_eu_100,
            trans1_scale_loc_out2_to_eu_0,
            trans1_scale_loc_out2_data_type,
            trans1_scale_loc_out2_slave_address,
            trans1_scale_loc_out2_function_code,
            trans1_scale_loc_out2_reg_addr_of_value,
            trans1_scale_loc_out2_reg_addr_of_status
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_mod_out3
{
    BLOCK transducer_block_1;
    INDEX 35;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_mod_out3_value,
            trans1_mod_out3_status_quality <0xFC>,
            trans1_mod_out3_status_limit   <0x03>
        }
    }
}
COMMAND read_trans1_scale_loc_out3
{
    BLOCK transducer_block_1;
    INDEX 36;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_scale_loc_out3_from_eu_100,
            trans1_scale_loc_out3_from_eu_0,
            trans1_scale_loc_out3_to_eu_100,
            trans1_scale_loc_out3_to_eu_0,
            trans1_scale_loc_out3_data_type,
            trans1_scale_loc_out3_slave_address,
            trans1_scale_loc_out3_function_code,
            trans1_scale_loc_out3_reg_addr_of_value,
            trans1_scale_loc_out3_reg_addr_of_status
        }
    }
}
COMMAND write_trans1_scale_loc_out3
{
    BLOCK transducer_block_1;
    INDEX 36;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_scale_loc_out3_from_eu_100,
            trans1_scale_loc_out3_from_eu_0,
            trans1_scale_loc_out3_to_eu_100,
            trans1_scale_loc_out3_to_eu_0,
            trans1_scale_loc_out3_data_type,
            trans1_scale_loc_out3_slave_address,
            trans1_scale_loc_out3_function_code,
            trans1_scale_loc_out3_reg_addr_of_value,
            trans1_scale_loc_out3_reg_addr_of_status
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_mod_out4
{
    BLOCK transducer_block_1;
    INDEX 37;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_mod_out4_value,
            trans1_mod_out4_status_quality <0xFC>,
            trans1_mod_out4_status_limit   <0x03>
        }
    }
}
COMMAND read_trans1_scale_loc_out4
{
    BLOCK transducer_block_1;
    INDEX 38;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_scale_loc_out4_from_eu_100,
            trans1_scale_loc_out4_from_eu_0,
            trans1_scale_loc_out4_to_eu_100,
            trans1_scale_loc_out4_to_eu_0,
            trans1_scale_loc_out4_data_type,
            trans1_scale_loc_out4_slave_address,
            trans1_scale_loc_out4_function_code,
            trans1_scale_loc_out4_reg_addr_of_value,
            trans1_scale_loc_out4_reg_addr_of_status
        }
    }
}
COMMAND write_trans1_scale_loc_out4
{
    BLOCK transducer_block_1;
    INDEX 38;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_scale_loc_out4_from_eu_100,
            trans1_scale_loc_out4_from_eu_0,
            trans1_scale_loc_out4_to_eu_100,
            trans1_scale_loc_out4_to_eu_0,
            trans1_scale_loc_out4_data_type,
            trans1_scale_loc_out4_slave_address,
            trans1_scale_loc_out4_function_code,
            trans1_scale_loc_out4_reg_addr_of_value,
            trans1_scale_loc_out4_reg_addr_of_status
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_mod_in_d1
{
    BLOCK transducer_block_1;
    INDEX 39;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_mod_in_d1_value,
            trans1_mod_in_d1_status_quality <0xFC>,
            trans1_mod_in_d1_status_limit   <0x03>
        }
    }
}
COMMAND read_trans1_loc_in_d1
{
    BLOCK transducer_block_1;
    INDEX 40;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_loc_in_d1_data_type,
            trans1_loc_in_d1_slave_address,
            trans1_loc_in_d1_function_code,
            trans1_loc_in_d1_reg_addr_of_value,
            trans1_loc_in_d1_reg_addr_of_status
        }
    }
}
COMMAND write_trans1_loc_in_d1
{
    BLOCK transducer_block_1;
    INDEX 40;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_loc_in_d1_data_type,
            trans1_loc_in_d1_slave_address,
            trans1_loc_in_d1_function_code,
            trans1_loc_in_d1_reg_addr_of_value,
            trans1_loc_in_d1_reg_addr_of_status
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_mod_in_d2
{
    BLOCK transducer_block_1;
    INDEX 41;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_mod_in_d2_value,
            trans1_mod_in_d2_status_quality <0xFC>,
            trans1_mod_in_d2_status_limit   <0x03>
        }
    }
}
COMMAND read_trans1_loc_in_d2
{
    BLOCK transducer_block_1;
    INDEX 42;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_loc_in_d2_data_type,
            trans1_loc_in_d2_slave_address,
            trans1_loc_in_d2_function_code,
            trans1_loc_in_d2_reg_addr_of_value,
            trans1_loc_in_d2_reg_addr_of_status
        }
    }
}
COMMAND write_trans1_loc_in_d2
{
    BLOCK transducer_block_1;
    INDEX 42;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_loc_in_d2_data_type,
            trans1_loc_in_d2_slave_address,
            trans1_loc_in_d2_function_code,
            trans1_loc_in_d2_reg_addr_of_value,
            trans1_loc_in_d2_reg_addr_of_status
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_mod_in_d3
{
    BLOCK transducer_block_1;
    INDEX 43;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_mod_in_d3_value,
            trans1_mod_in_d3_status_quality <0xFC>,
            trans1_mod_in_d3_status_limit   <0x03>
        }
    }
}
COMMAND read_trans1_loc_in_d3
{
    BLOCK transducer_block_1;
    INDEX 44;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_loc_in_d3_data_type,
            trans1_loc_in_d3_slave_address,
            trans1_loc_in_d3_function_code,
            trans1_loc_in_d3_reg_addr_of_value,
            trans1_loc_in_d3_reg_addr_of_status
        }
    }
}
COMMAND write_trans1_loc_in_d3
{
    BLOCK transducer_block_1;
    INDEX 44;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_loc_in_d3_data_type,
            trans1_loc_in_d3_slave_address,
            trans1_loc_in_d3_function_code,
            trans1_loc_in_d3_reg_addr_of_value,
            trans1_loc_in_d3_reg_addr_of_status
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_mod_in_d4
{
    BLOCK transducer_block_1;
    INDEX 45;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_mod_in_d4_value,
            trans1_mod_in_d4_status_quality <0xFC>,
            trans1_mod_in_d4_status_limit   <0x03>
        }
    }
}
COMMAND read_trans1_loc_in_d4
{
    BLOCK transducer_block_1;
    INDEX 46;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_loc_in_d4_data_type,
            trans1_loc_in_d4_slave_address,
            trans1_loc_in_d4_function_code,
            trans1_loc_in_d4_reg_addr_of_value,
            trans1_loc_in_d4_reg_addr_of_status
        }
    }
}
COMMAND write_trans1_loc_in_d4
{
    BLOCK transducer_block_1;
    INDEX 46;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_loc_in_d4_data_type,
            trans1_loc_in_d4_slave_address,
            trans1_loc_in_d4_function_code,
            trans1_loc_in_d4_reg_addr_of_value,
            trans1_loc_in_d4_reg_addr_of_status
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_mod_out_d1
{
    BLOCK transducer_block_1;
    INDEX 47;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_mod_out_d1_value,
            trans1_mod_out_d1_status_quality <0xFC>,
            trans1_mod_out_d1_status_limit   <0x03>
        }
    }
}
COMMAND read_trans1_loc_out_d1
{
    BLOCK transducer_block_1;
    INDEX 48;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_loc_out_d1_data_type,
            trans1_loc_out_d1_slave_address,
            trans1_loc_out_d1_function_code,
            trans1_loc_out_d1_reg_addr_of_value,
            trans1_loc_out_d1_reg_addr_of_status
        }
    }
}
COMMAND write_trans1_loc_out_d1
{
    BLOCK transducer_block_1;
    INDEX 48;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_loc_out_d1_data_type,
            trans1_loc_out_d1_slave_address,
            trans1_loc_out_d1_function_code,
            trans1_loc_out_d1_reg_addr_of_value,
            trans1_loc_out_d1_reg_addr_of_status
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_mod_out_d2
{
    BLOCK transducer_block_1;
    INDEX 49;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_mod_out_d2_value,
            trans1_mod_out_d2_status_quality <0xFC>,
            trans1_mod_out_d2_status_limit   <0x03>
        }
    }
}
COMMAND read_trans1_loc_out_d2
{
    BLOCK transducer_block_1;
    INDEX 50;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_loc_out_d2_data_type,
            trans1_loc_out_d2_slave_address,
            trans1_loc_out_d2_function_code,
            trans1_loc_out_d2_reg_addr_of_value,
            trans1_loc_out_d2_reg_addr_of_status
        }
    }
}
COMMAND write_trans1_loc_out_d2
{
    BLOCK transducer_block_1;
    INDEX 50;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_loc_out_d2_data_type,
            trans1_loc_out_d2_slave_address,
            trans1_loc_out_d2_function_code,
            trans1_loc_out_d2_reg_addr_of_value,
            trans1_loc_out_d2_reg_addr_of_status
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_mod_out_d3
{
    BLOCK transducer_block_1;
    INDEX 51;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_mod_out_d3_value,
            trans1_mod_out_d3_status_quality <0xFC>,
            trans1_mod_out_d3_status_limit   <0x03>
        }
    }
}
COMMAND read_trans1_loc_out_d3
{
    BLOCK transducer_block_1;
    INDEX 52;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_loc_out_d3_data_type,
            trans1_loc_out_d3_slave_address,
            trans1_loc_out_d3_function_code,
            trans1_loc_out_d3_reg_addr_of_value,
            trans1_loc_out_d3_reg_addr_of_status
        }
    }
}
COMMAND write_trans1_loc_out_d3
{
    BLOCK transducer_block_1;
    INDEX 52;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_loc_out_d3_data_type,
            trans1_loc_out_d3_slave_address,
            trans1_loc_out_d3_function_code,
            trans1_loc_out_d3_reg_addr_of_value,
            trans1_loc_out_d3_reg_addr_of_status
        }
        REPLY
        {
        }
    }
}
COMMAND read_trans1_mod_out_d4
{
    BLOCK transducer_block_1;
    INDEX 53;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_mod_out_d4_value,
            trans1_mod_out_d4_status_quality <0xFC>,
            trans1_mod_out_d4_status_limit   <0x03>
        }
    }
}
COMMAND read_trans1_loc_out_d4
{
    BLOCK transducer_block_1;
    INDEX 54;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            trans1_loc_out_d4_data_type,
            trans1_loc_out_d4_slave_address,
            trans1_loc_out_d4_function_code,
            trans1_loc_out_d4_reg_addr_of_value,
            trans1_loc_out_d4_reg_addr_of_status
        }
    }
}
COMMAND write_trans1_loc_out_d4
{
    BLOCK transducer_block_1;
    INDEX 54;
    OPERATION WRITE;
    TRANSACTION
    {
        REQUEST
        {
            trans1_loc_out_d4_data_type,
            trans1_loc_out_d4_slave_address,
            trans1_loc_out_d4_function_code,
            trans1_loc_out_d4_reg_addr_of_value,
            trans1_loc_out_d4_reg_addr_of_status
        }
        REPLY
        {
        }
    }
}

/***********************************************************************/
/*    Menu                                                             */
/***********************************************************************/
MENU Page_diagnosis_trans1_modbus
{
    LABEL        "Modbus Transducer";
    ITEMS
    {
        trans1_blk_object,
        trans1_blk_parent_class,
        trans1_blk_class,
        trans1_blk_dd_reference,
        trans1_blk_dd_rev,
        trans1_blk_profile,
        trans1_blk_profile_rev,
        trans1_st_rev,
        trans1_actual_mode
    }
}

MENU Menu_s_config_modbus
{
    LABEL  "Modbus Configuration";
    ITEMS
    {
        OnlineDialog_s_comm_para,    
        OnlineDialog_s_error_lookup,    
        OnlineDialog_s_analog_input,    
        OnlineDialog_s_analog_output,    
        OnlineDialog_s_discrete_input,
        OnlineDialog_s_discrete_output
    }
}

MENU OnlineDialog_s_comm_para
{
    LABEL    "Modbus Communication Setting";
    ITEMS
    {
        trans1_target_mode,
        trans1_actual_mode,
//        trans1_media,
        trans1_baud_rate,
        trans1_stop_bits,      
        SEPARATOR,
        trans1_parity,         
        trans1_crc_order,      
        trans1_time_out,       
        trans1_number_of_retry,
        trans1_slave_address_1,
        trans1_slave_address_2,
        trans1_slave_address_3,
        trans1_slave_address_4,
        method_set
    }
}

MENU OnlineDialog_s_error_lookup
{
    LABEL    "Modbus Error Lookup";
    ITEMS
    {
        trans1_bad_status,
        trans1_err_look_sel,
        trans1_err_look_result,
        method_set
    }
}

MENU OnlineDialog_s_analog_input
{
    LABEL    "Modbus Analog Input";
    ITEMS
    {
        Page_s_modbus_mod_in1,
        Page_s_modbus_mod_in2,
        Page_s_modbus_mod_in3,
        Page_s_modbus_mod_in4
    }
}

MENU OnlineDialog_s_analog_output
{
    LABEL    "Modbus Analog Output";
    ITEMS
    {
        Page_s_modbus_mod_out1,
        Page_s_modbus_mod_out2,
        Page_s_modbus_mod_out3,
        Page_s_modbus_mod_out4
    }
}

MENU OnlineDialog_s_discrete_input
{
    LABEL    "Modbus Discrete Input";
    ITEMS
    {
        Page_s_modbus_mod_in_d1,
        Page_s_modbus_mod_in_d2,
        Page_s_modbus_mod_in_d3,
        Page_s_modbus_mod_in_d4
    }
}

MENU OnlineDialog_s_discrete_output
{
    LABEL    "Modbus Discrete Output";
    ITEMS
    {
        Page_s_modbus_mod_out_d1,
        Page_s_modbus_mod_out_d2,
        Page_s_modbus_mod_out_d3,
        Page_s_modbus_mod_out_d4
    }
}

MENU Group_trans1_error_lookup
{
    LABEL    "Error Lookup";
    ITEMS
    {
        trans1_err_look_sel,
        trans1_err_look_result
   }
}

MENU Group_trans1_mod_in1
{
    LABEL    "Analog Input 1";
    ITEMS
    {
        trans1_mod_in1_value,
        trans1_mod_in1_status_quality,
        trans1_mod_in1_status_limit
   }
}

MENU Group_trans1_mod_in2
{
    LABEL    "Analog Input 2";
    ITEMS
    {
        trans1_mod_in2_value,
        trans1_mod_in2_status_quality,
        trans1_mod_in2_status_limit
   }
}

MENU Group_trans1_mod_in3
{
    LABEL    "Analog Input 3";
    ITEMS
    {
        trans1_mod_in3_value,
        trans1_mod_in3_status_quality,
        trans1_mod_in3_status_limit
   }
}

MENU Group_trans1_mod_in4
{
    LABEL    "Analog Input 4";
    ITEMS
    {
        trans1_mod_in4_value,
        trans1_mod_in4_status_quality,
        trans1_mod_in4_status_limit
   }
}

MENU Group_trans1_mod_out1
{
    LABEL    "Analog Output 1";
    ITEMS
    {
        trans1_mod_out1_value,
        trans1_mod_out1_status_quality,
        trans1_mod_out1_status_limit
   }
}

MENU Group_trans1_mod_out2
{
    LABEL    "Analog Output 2";
    ITEMS
    {
        trans1_mod_out2_value,
        trans1_mod_out2_status_quality,
        trans1_mod_out2_status_limit
   }
}

MENU Group_trans1_mod_out3
{
    LABEL    "Analog Output 3";
    ITEMS
    {
        trans1_mod_out3_value,
        trans1_mod_out3_status_quality,
        trans1_mod_out3_status_limit
   }
}

MENU Group_trans1_mod_out4
{
    LABEL    "Analog Output 4";
    ITEMS
    {
        trans1_mod_out4_value,
        trans1_mod_out4_status_quality,
        trans1_mod_out4_status_limit
   }
}

MENU Group_trans1_mod_in_d1
{
    LABEL    "Discrete Input 1";
    ITEMS
    {
        trans1_mod_in_d1_value,
        trans1_mod_in_d1_status_quality,
        trans1_mod_in_d1_status_limit
   }
}

MENU Group_trans1_mod_in_d2
{
    LABEL    "Discrete Input 2";
    ITEMS
    {
        trans1_mod_in_d2_value,
        trans1_mod_in_d2_status_quality,
        trans1_mod_in_d2_status_limit
   }
}

MENU Group_trans1_mod_in_d3
{
    LABEL    "Discrete Input 3";
    ITEMS
    {
        trans1_mod_in_d3_value,
        trans1_mod_in_d3_status_quality,
        trans1_mod_in_d3_status_limit
   }
}

MENU Group_trans1_mod_in_d4
{
    LABEL    "Discrete Input 4";
    ITEMS
    {
        trans1_mod_in_d4_value,
        trans1_mod_in_d4_status_quality,
        trans1_mod_in_d4_status_limit
   }
}

MENU Group_trans1_mod_out_d1
{
    LABEL    "Discrete Output 1";
    ITEMS
    {
        trans1_mod_out_d1_value,
        trans1_mod_out_d1_status_quality,
        trans1_mod_out_d1_status_limit
   }
}

MENU Group_trans1_mod_out_d2
{
    LABEL    "Discrete Output 2";
    ITEMS
    {
        trans1_mod_out_d2_value,
        trans1_mod_out_d2_status_quality,
        trans1_mod_out_d2_status_limit
   }
}

MENU Group_trans1_mod_out_d3
{
    LABEL    "Discrete Output 3";
    ITEMS
    {
        trans1_mod_out_d3_value,
        trans1_mod_out_d3_status_quality,
        trans1_mod_out_d3_status_limit
   }
}

MENU Group_trans1_mod_out_d4
{
    LABEL    "Discrete Output 4";
    ITEMS
    {
        trans1_mod_out_d4_value,
        trans1_mod_out_d4_status_quality,
        trans1_mod_out_d4_status_limit
   }
}

MENU Group_trans1_scale_loc_in1
{
    LABEL    "Scale Location In 1";
    ITEMS
    {
        trans1_scale_loc_in1_from_eu_100,
        trans1_scale_loc_in1_from_eu_0,
        trans1_scale_loc_in1_to_eu_100,
        trans1_scale_loc_in1_to_eu_0,
        trans1_scale_loc_in1_data_type,
        trans1_scale_loc_in1_slave_address (READ_ONLY),
        trans1_scale_loc_in1_function_code,
        trans1_scale_loc_in1_reg_addr_of_value,
        trans1_scale_loc_in1_reg_addr_of_status
   }
}

MENU Group_trans1_scale_loc_in2
{
    LABEL    "Scale Location In 2";
    ITEMS
    {
        trans1_scale_loc_in2_from_eu_100,
        trans1_scale_loc_in2_from_eu_0,
        trans1_scale_loc_in2_to_eu_100,
        trans1_scale_loc_in2_to_eu_0,
        trans1_scale_loc_in2_data_type,
        trans1_scale_loc_in2_slave_address (READ_ONLY),
        trans1_scale_loc_in2_function_code,
        trans1_scale_loc_in2_reg_addr_of_value,
        trans1_scale_loc_in2_reg_addr_of_status
   }
}

MENU Group_trans1_scale_loc_in3
{
    LABEL    "Scale Location In 3";
    ITEMS
    {
        trans1_scale_loc_in3_from_eu_100,
        trans1_scale_loc_in3_from_eu_0,
        trans1_scale_loc_in3_to_eu_100,
        trans1_scale_loc_in3_to_eu_0,
        trans1_scale_loc_in3_data_type,
        trans1_scale_loc_in3_slave_address (READ_ONLY),
        trans1_scale_loc_in3_function_code,
        trans1_scale_loc_in3_reg_addr_of_value,
        trans1_scale_loc_in3_reg_addr_of_status
   }
}

MENU Group_trans1_scale_loc_in4
{
    LABEL    "Scale Location In 4";
    ITEMS
    {
        trans1_scale_loc_in4_from_eu_100,
        trans1_scale_loc_in4_from_eu_0,
        trans1_scale_loc_in4_to_eu_100,
        trans1_scale_loc_in4_to_eu_0,
        trans1_scale_loc_in4_data_type,
        trans1_scale_loc_in4_slave_address (READ_ONLY),
        trans1_scale_loc_in4_function_code,
        trans1_scale_loc_in4_reg_addr_of_value,
        trans1_scale_loc_in4_reg_addr_of_status
   }
}

MENU Group_trans1_scale_loc_out1
{
    LABEL    "Scale Location Out 1";
    ITEMS
    {
        trans1_scale_loc_out1_from_eu_100,
        trans1_scale_loc_out1_from_eu_0,
        trans1_scale_loc_out1_to_eu_100,
        trans1_scale_loc_out1_to_eu_0,
        trans1_scale_loc_out1_data_type,
        trans1_scale_loc_out1_slave_address (READ_ONLY),
        trans1_scale_loc_out1_function_code,
        trans1_scale_loc_out1_reg_addr_of_value,
        trans1_scale_loc_out1_reg_addr_of_status
   }
}

MENU Group_trans1_scale_loc_out2
{
    LABEL    "Scale Location Out 2";
    ITEMS
    {
        trans1_scale_loc_out2_from_eu_100,
        trans1_scale_loc_out2_from_eu_0,
        trans1_scale_loc_out2_to_eu_100,
        trans1_scale_loc_out2_to_eu_0,
        trans1_scale_loc_out2_data_type,
        trans1_scale_loc_out2_slave_address (READ_ONLY),
        trans1_scale_loc_out2_function_code,
        trans1_scale_loc_out2_reg_addr_of_value,
        trans1_scale_loc_out2_reg_addr_of_status
   }
}

MENU Group_trans1_scale_loc_out3
{
    LABEL    "Scale Location Out 3";
    ITEMS
    {
        trans1_scale_loc_out3_from_eu_100,
        trans1_scale_loc_out3_from_eu_0,
        trans1_scale_loc_out3_to_eu_100,
        trans1_scale_loc_out3_to_eu_0,
        trans1_scale_loc_out3_data_type,
        trans1_scale_loc_out3_slave_address (READ_ONLY),
        trans1_scale_loc_out3_function_code,
        trans1_scale_loc_out3_reg_addr_of_value,
        trans1_scale_loc_out3_reg_addr_of_status
   }
}

MENU Group_trans1_scale_loc_out4
{
    LABEL    "Scale Location Out 4";
    ITEMS
    {
        trans1_scale_loc_out4_from_eu_100,
        trans1_scale_loc_out4_from_eu_0,
        trans1_scale_loc_out4_to_eu_100,
        trans1_scale_loc_out4_to_eu_0,
        trans1_scale_loc_out4_data_type,
        trans1_scale_loc_out4_slave_address (READ_ONLY),
        trans1_scale_loc_out4_function_code,
        trans1_scale_loc_out4_reg_addr_of_value,
        trans1_scale_loc_out4_reg_addr_of_status
   }
}

MENU Group_trans1_loc_in_d1
{
    LABEL    "Location In_D 1";
    ITEMS
    {
        trans1_loc_in_d1_data_type,
        trans1_loc_in_d1_slave_address (READ_ONLY),
        trans1_loc_in_d1_function_code,
        trans1_loc_in_d1_reg_addr_of_value,
        trans1_loc_in_d1_reg_addr_of_status
   }
}

MENU Group_trans1_loc_in_d2
{
    LABEL    "Location In_D 2";
    ITEMS
    {
        trans1_loc_in_d2_data_type,
        trans1_loc_in_d2_slave_address (READ_ONLY),
        trans1_loc_in_d2_function_code,
        trans1_loc_in_d2_reg_addr_of_value,
        trans1_loc_in_d2_reg_addr_of_status
   }
}

MENU Group_trans1_loc_in_d3
{
    LABEL    "Location In_D 3";
    ITEMS
    {
        trans1_loc_in_d3_data_type,
        trans1_loc_in_d3_slave_address (READ_ONLY),
        trans1_loc_in_d3_function_code,
        trans1_loc_in_d3_reg_addr_of_value,
        trans1_loc_in_d3_reg_addr_of_status
   }
}

MENU Group_trans1_loc_in_d4
{
    LABEL    "Location In_D 4";
    ITEMS
    {
        trans1_loc_in_d4_data_type,
        trans1_loc_in_d4_slave_address (READ_ONLY),
        trans1_loc_in_d4_function_code,
        trans1_loc_in_d4_reg_addr_of_value,
        trans1_loc_in_d4_reg_addr_of_status
   }
}

MENU Group_trans1_loc_out_d1
{
    LABEL    "Location Out_D 1";
    ITEMS
    {
        trans1_loc_out_d1_data_type,
        trans1_loc_out_d1_slave_address (READ_ONLY),
        trans1_loc_out_d1_function_code,
        trans1_loc_out_d1_reg_addr_of_value,
        trans1_loc_out_d1_reg_addr_of_status
   }
}

MENU Group_trans1_loc_out_d2
{
    LABEL    "Location Out_D 2";
    ITEMS
    {
        trans1_loc_out_d2_data_type,
        trans1_loc_out_d2_slave_address (READ_ONLY),
        trans1_loc_out_d2_function_code,
        trans1_loc_out_d2_reg_addr_of_value,
        trans1_loc_out_d2_reg_addr_of_status
   }
}

MENU Group_trans1_loc_out_d3
{
    LABEL    "Location Out_D 3";
    ITEMS
    {
        trans1_loc_out_d3_data_type,
        trans1_loc_out_d3_slave_address (READ_ONLY),
        trans1_loc_out_d3_function_code,
        trans1_loc_out_d3_reg_addr_of_value,
        trans1_loc_out_d3_reg_addr_of_status
   }
}

MENU Group_trans1_loc_out_d4
{
    LABEL    "Location Out_D 4";
    ITEMS
    {
        trans1_loc_out_d4_data_type,
        trans1_loc_out_d4_slave_address (READ_ONLY),
        trans1_loc_out_d4_function_code,
        trans1_loc_out_d4_reg_addr_of_value,
        trans1_loc_out_d4_reg_addr_of_status
   }
}

MENU Page_s_modbus_mod_in1
{
    LABEL    "Modbus Mod In 1";
    ITEMS
    {
        Group_trans1_mod_in1,
        Group_trans1_error_lookup,
        SEPARATOR,
        Group_trans1_scale_loc_in1,
        method_set
   }
}

MENU Page_s_modbus_mod_in2
{
    LABEL    "Modbus Mod In 2";
    ITEMS
    {
        Group_trans1_mod_in2,
        Group_trans1_error_lookup,
        SEPARATOR,
        Group_trans1_scale_loc_in2,
        method_set
   }
}

MENU Page_s_modbus_mod_in3
{
    LABEL    "Modbus Mod In 3";
    ITEMS
    {
        Group_trans1_mod_in3,
        Group_trans1_error_lookup,
        SEPARATOR,
        Group_trans1_scale_loc_in3,
        method_set
   }
}

MENU Page_s_modbus_mod_in4
{
    LABEL    "Modbus Mod In 4";
    ITEMS
    {
        Group_trans1_mod_in4,
        Group_trans1_error_lookup,
        SEPARATOR,
        Group_trans1_scale_loc_in4,
        method_set
   }
}

MENU Page_s_modbus_mod_out1
{
    LABEL    "Modbus Mod Out 1";
    ITEMS
    {
        Group_trans1_mod_out1,
        Group_trans1_error_lookup,
        SEPARATOR,
        Group_trans1_scale_loc_out1,
        method_set
   }
}

MENU Page_s_modbus_mod_out2
{
    LABEL    "Modbus Mod Out 2";
    ITEMS
    {
        Group_trans1_mod_out2,
        Group_trans1_error_lookup,
        SEPARATOR,
        Group_trans1_scale_loc_out2,
        method_set
   }
}

MENU Page_s_modbus_mod_out3
{
    LABEL    "Modbus Mod Out 3";
    ITEMS
    {
        Group_trans1_mod_out3,
        Group_trans1_error_lookup,
        SEPARATOR,
        Group_trans1_scale_loc_out3,
        method_set
   }
}

MENU Page_s_modbus_mod_out4
{
    LABEL    "Modbus Mod Out 4";
    ITEMS
    {
        Group_trans1_mod_out4,
        Group_trans1_error_lookup,
        SEPARATOR,
        Group_trans1_scale_loc_out4,
        method_set
   }
}

MENU Page_s_modbus_mod_in_d1
{
    LABEL    "Modbus Mod In_D 1";
    ITEMS
    {
        Group_trans1_mod_in_d1,
        Group_trans1_error_lookup,
        SEPARATOR,
        Group_trans1_loc_in_d1,
        method_set
   }
}

MENU Page_s_modbus_mod_in_d2
{
    LABEL    "Modbus Mod In_D 2";
    ITEMS
    {
        Group_trans1_mod_in_d2,
        Group_trans1_error_lookup,
        SEPARATOR,
        Group_trans1_loc_in_d2,
        method_set
   }
}

MENU Page_s_modbus_mod_in_d3
{
    LABEL    "Modbus Mod In_D 3";
    ITEMS
    {
        Group_trans1_mod_in_d3,
        Group_trans1_error_lookup,
        SEPARATOR,
        Group_trans1_loc_in_d3,
        method_set
   }
}

MENU Page_s_modbus_mod_in_d4
{
    LABEL    "Modbus Mod In_D 4";
    ITEMS
    {
        Group_trans1_mod_in_d4,
        Group_trans1_error_lookup,
        SEPARATOR,
        Group_trans1_loc_in_d4,
        method_set
   }
}

MENU Page_s_modbus_mod_out_d1
{
    LABEL    "Modbus Mod Out_D 1";
    ITEMS
    {
        Group_trans1_mod_out_d1,
        Group_trans1_error_lookup,
        SEPARATOR,
        Group_trans1_loc_out_d1,
        method_set
   }
}

MENU Page_s_modbus_mod_out_d2
{
    LABEL    "Modbus Mod Out_D 2";
    ITEMS
    {
        Group_trans1_mod_out_d2,
        Group_trans1_error_lookup,
        SEPARATOR,
        Group_trans1_loc_out_d2,
        method_set
   }
}

MENU Page_s_modbus_mod_out_d3
{
    LABEL    "Modbus Mod Out_D 3";
    ITEMS
    {
        Group_trans1_mod_out_d3,
        Group_trans1_error_lookup,
        SEPARATOR,
        Group_trans1_loc_out_d3,
        method_set
   }
}

MENU Page_s_modbus_mod_out_d4
{
    LABEL    "Modbus Mod Out_D 4";
    ITEMS
    {
        Group_trans1_mod_out_d4,
        Group_trans1_error_lookup,
        SEPARATOR,
        Group_trans1_loc_out_d4,
        method_set
   }
}

MENU Tab_s_modbus_trd
{
    LABEL        "Modbus Transducer";
    ITEMS
    {
        trans1_st_rev,
//        trans1_media,
        trans1_baud_rate,
        trans1_stop_bits,      
        trans1_parity,         
        trans1_crc_order,      
        trans1_time_out,       
        trans1_number_of_retry,
        trans1_slave_address_1,
        trans1_slave_address_2,
        trans1_slave_address_3,
        trans1_slave_address_4
    }
}

METHOD method_set_comm_para
{
    LABEL [MC_Write];
    DEFINITION
    {
        WriteCommand(write_trans1_target_mode);
//        WriteCommand(write_trans1_media);
        WriteCommand(write_trans1_baud_rate);
        WriteCommand(write_trans1_stop_bits);
        WriteCommand(write_trans1_parity);
        WriteCommand(write_trans1_crc_order);
        WriteCommand(write_trans1_number_of_retry);
        WriteCommand(write_trans1_slave_address);
        ReadCommand(read_trans1_target_mode);
//        ReadCommand(read_trans1_media);
        ReadCommand(read_trans1_baud_rate);
        ReadCommand(read_trans1_stop_bits);
        ReadCommand(read_trans1_parity);
        ReadCommand(read_trans1_crc_order);
        ReadCommand(read_trans1_number_of_retry);
        ReadCommand(read_trans1_slave_address);
    }
}

METHOD method_set_slave_address_1
{
    LABEL "";
    DEFINITION
    {
        trans1_scale_loc_in1_slave_address  = trans1_slave_address_1;
        trans1_scale_loc_out1_slave_address = trans1_slave_address_1;
        trans1_loc_in_d1_slave_address      = trans1_slave_address_1;
        trans1_loc_out_d1_slave_address     = trans1_slave_address_1;
    }
}

METHOD method_set_slave_address_2
{
    LABEL "";
    DEFINITION
    {
        trans1_scale_loc_in2_slave_address  = trans1_slave_address_2;
        trans1_scale_loc_out2_slave_address = trans1_slave_address_2;
        trans1_loc_in_d2_slave_address      = trans1_slave_address_2;
        trans1_loc_out_d2_slave_address     = trans1_slave_address_2;
    }
}

METHOD method_set_slave_address_3
{
    LABEL "";
    DEFINITION
    {
        trans1_scale_loc_in3_slave_address  = trans1_slave_address_3;
        trans1_scale_loc_out3_slave_address = trans1_slave_address_3;
        trans1_loc_in_d3_slave_address      = trans1_slave_address_3;
        trans1_loc_out_d3_slave_address     = trans1_slave_address_3;
    }
}

METHOD method_set_slave_address_4
{
    LABEL "";
    DEFINITION
    {
        trans1_scale_loc_in4_slave_address  = trans1_slave_address_4;
        trans1_scale_loc_out4_slave_address = trans1_slave_address_4;
        trans1_loc_in_d4_slave_address      = trans1_slave_address_4;
        trans1_loc_out_d4_slave_address     = trans1_slave_address_4;
    }
}
